import { SwapConfig, SwapRebalance, TransactionParams } from '../interfaces';
/**
 * Rebalance the proportion of results in the proportion of demand and the priority given to the small deficit and return a response for the Augustus contract
 * @param swapData: SwapRebalance
 * @param configSwap: SwapConfig
 * @returns an array of TransactionsToParaswap[]
 */
export declare const rebalanceByMinDebitPriority: (swapData: SwapRebalance, configSwap: SwapConfig) => Promise<TransactionParams[]>;
/**
 * Rebalance the proportion of results in the proportion of demand based on the priority of activities and return a response for the Augustus contract
 * @param swapData
 * @param configSwap
 * @returns an array of TransactionsToParaswap[]
 */
export declare const rebalanceByAssetsPriority: (swapData: SwapRebalance, configSwap: SwapConfig) => Promise<TransactionParams[]>;
