import { BigNumber } from 'ethers';
import * as paraHP from '../interfaces';
import { ITokenConfig, MinTokenData } from '../interfaces';
import * as paraType from '../type';
import { ESupportedNetworks } from '../enums';
export declare const getSwapCost: (srcToken: Pick<MinTokenData, 'address' | 'decimals'>, destToken: Pick<MinTokenData, 'address' | 'decimals'>, srcAmount: paraType.NumberAsString, networkID: number) => Promise<BigNumber>;
export declare function getToken(address: paraType.Address, decimal: number): paraHP.MinTokenData;
export declare const getTokenPropertiesFromAddress: (chainId: ESupportedNetworks, tokenAddress: string) => ITokenConfig;
export declare function getSwapTransaction(swapTxInPut: paraHP.GetSwapTxInput): Promise<paraHP.TransactionParams>;
