"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSwapTransaction = exports.getTokenPropertiesFromAddress = exports.getToken = exports.getSwapCost = void 0;
var ethers_1 = require("ethers");
var paraswap_core_1 = require("paraswap-core");
var cross_fetch_1 = require("cross-fetch");
var stealth_defi_config_1 = require("stealth-defi-config");
var API_URL = 'https://apiv5.paraswap.io';
var getSwapCost = function (srcToken, destToken, srcAmount, networkID) { return __awaiter(void 0, void 0, void 0, function () {
    var queryParams, searchString, pricesURL, response, priceRoute, cost, error_1;
    var _a, _b, _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _d.trys.push([0, 3, , 4]);
                queryParams = {
                    srcToken: srcToken.address,
                    destToken: destToken.address,
                    srcDecimals: srcToken.decimals.toString(),
                    destDecimals: destToken.decimals.toString(),
                    amount: ethers_1.ethers.BigNumber.from(srcAmount).toString(),
                    side: paraswap_core_1.SwapSide.SELL,
                    network: networkID.toString(),
                    maxImpact: '100',
                    // maxImpact: '10000',
                };
                searchString = new URLSearchParams(queryParams);
                pricesURL = "".concat(API_URL, "/prices/?").concat(searchString);
                return [4 /*yield*/, (0, cross_fetch_1.fetch)(pricesURL, { method: 'GET' })];
            case 1:
                response = _d.sent();
                return [4 /*yield*/, response.json()];
            case 2:
                priceRoute = (_d.sent()).priceRoute;
                cost = ethers_1.BigNumber.from(priceRoute.gasCostUSD)
                    .add(ethers_1.BigNumber.from(priceRoute.srcUSD))
                    .sub(ethers_1.BigNumber.from(priceRoute.destUSD));
                return [2 /*return*/, cost];
            case 3:
                error_1 = _d.sent();
                console.error((_a = error_1 === null || error_1 === void 0 ? void 0 : error_1.response) === null || _a === void 0 ? void 0 : _a.data);
                throw new Error((_c = (_b = error_1 === null || error_1 === void 0 ? void 0 : error_1.response) === null || _b === void 0 ? void 0 : _b.data) === null || _c === void 0 ? void 0 : _c.error);
            case 4: return [2 /*return*/];
        }
    });
}); };
exports.getSwapCost = getSwapCost;
function getToken(address, decimal) {
    var token = {
        decimals: decimal,
        address: address,
    };
    return token;
}
exports.getToken = getToken;
function createSwapper(networkID, apiURL) {
    var _this = this;
    try {
        var getRate = function (_a) {
            var srcToken = _a.srcToken, destToken = _a.destToken, srcAmount = _a.srcAmount, maxImpact = _a.maxImpact;
            return __awaiter(_this, void 0, void 0, function () {
                var queryParams, searchString, pricesURL, response, priceRoute;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            queryParams = {
                                srcToken: srcToken.address,
                                destToken: destToken.address,
                                srcDecimals: srcToken.decimals.toString(),
                                destDecimals: destToken.decimals.toString(),
                                amount: srcAmount,
                                side: paraswap_core_1.SwapSide.SELL,
                                network: networkID.toString(),
                                maxImpact: maxImpact,
                            };
                            searchString = new URLSearchParams(queryParams);
                            pricesURL = "".concat(apiURL, "/prices/?").concat(searchString);
                            return [4 /*yield*/, (0, cross_fetch_1.fetch)(pricesURL, { method: 'GET' })];
                        case 1:
                            response = _b.sent();
                            return [4 /*yield*/, response.json()];
                        case 2:
                            priceRoute = (_b.sent()).priceRoute;
                            return [2 /*return*/, priceRoute];
                    }
                });
            });
        };
        var buildSwap = function (_a) {
            var srcToken = _a.srcToken, destToken = _a.destToken, srcAmount = _a.srcAmount, priceRoute = _a.priceRoute, userAddress = _a.userAddress, receiver = _a.receiver, partner = _a.partner, slippage = _a.slippage;
            return __awaiter(_this, void 0, void 0, function () {
                var txURL, slippageAsNumber, txConfig, response, data;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            txURL = "".concat(apiURL, "/transactions/").concat(networkID, "?ignoreChecks=true");
                            slippageAsNumber = parseInt(slippage.toString());
                            console.log('slippageAsNumber: ', slippageAsNumber);
                            txConfig = {
                                srcToken: srcToken.address,
                                destToken: destToken.address,
                                srcAmount: srcAmount,
                                //srcDecimals: srcToken.decimals,
                                priceRoute: priceRoute,
                                // destDecimals: destToken.decimals,
                                slippage: slippageAsNumber,
                                userAddress: userAddress,
                                partner: partner,
                                receiver: receiver,
                            };
                            return [4 /*yield*/, (0, cross_fetch_1.fetch)(txURL, {
                                    method: 'POST',
                                    headers: {
                                        'Content-Type': 'application/json',
                                    },
                                    body: JSON.stringify(txConfig),
                                })];
                        case 1:
                            response = _b.sent();
                            return [4 /*yield*/, response.json()];
                        case 2:
                            data = _b.sent();
                            return [2 /*return*/, data];
                    }
                });
            });
        };
        return { getRate: getRate, buildSwap: buildSwap };
    }
    catch (error) {
        console.error(error);
        throw new Error(error);
    }
}
var getTokenPropertiesFromAddress = function (chainId, tokenAddress) {
    var token = undefined;
    for (var x = 0; x < stealth_defi_config_1.sdconfig.supportedCurrencies.length; x++) {
        var tokenPropose = stealth_defi_config_1.sdconfig.supportedCurrencies[x].networks[chainId][0];
        if (tokenPropose.completed) {
            if (ethers_1.ethers.utils.getAddress(tokenPropose.address) == ethers_1.ethers.utils.getAddress(tokenAddress)) {
                // Need to checksum
                token = tokenPropose;
                return token;
            }
        }
    }
    if (token != undefined) {
        return token;
    }
    else {
        throw new Error('not an existing Token');
    }
};
exports.getTokenPropertiesFromAddress = getTokenPropertiesFromAddress;
function getSwapTransaction(swapTxInPut) {
    return __awaiter(this, void 0, void 0, function () {
        var srcTokenForPost, destTokenForPost, srcAmountForPost, ps, priceRoute, transactionRequest, error_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 3, , 4]);
                    srcTokenForPost = getToken(swapTxInPut.srcToken, swapTxInPut.srcDecimal);
                    destTokenForPost = getToken(swapTxInPut.destToken, swapTxInPut.destDecimal);
                    srcAmountForPost = ethers_1.ethers.BigNumber.from(swapTxInPut.srcAmount).toString();
                    ps = createSwapper(swapTxInPut.networkID, API_URL);
                    return [4 /*yield*/, ps.getRate({
                            srcToken: srcTokenForPost,
                            destToken: destTokenForPost,
                            srcAmount: srcAmountForPost,
                            maxImpact: swapTxInPut.maxImpact,
                        })];
                case 1:
                    priceRoute = _a.sent();
                    return [4 /*yield*/, ps.buildSwap({
                            srcToken: srcTokenForPost,
                            destToken: destTokenForPost,
                            srcAmount: srcAmountForPost,
                            priceRoute: priceRoute,
                            receiver: swapTxInPut.receiver,
                            userAddress: swapTxInPut.userAddress,
                            slippage: swapTxInPut.slippage,
                        })];
                case 2:
                    transactionRequest = _a.sent();
                    return [2 /*return*/, transactionRequest];
                case 3:
                    error_2 = _a.sent();
                    console.error(error_2);
                    throw new Error(error_2);
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.getSwapTransaction = getSwapTransaction;
//# sourceMappingURL=misc.js.map