"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatQueriesForParaswap = exports.performNaiveRebalancing = exports.performFillTheMinFirst = exports.maxCredit = exports.minDebit = exports.checkPropotions = exports.getDeltaProportion = void 0;
var hp = __importStar(require("./helper"));
var helper_1 = require("./helper");
var ethers_1 = require("ethers");
var config_1 = require("../config");
var enums_1 = require("../enums");
/**
 * Get the Delta between two Positions
 * @param from currentPositon
 * @param to DesiredPositons
 * @returns an array indicating the delta of each asset in the vault
 */
var getDeltaProportion = function (from, to) {
    var delta = [];
    for (var i = 0; i < from.length; i++) {
        delta.push(from[i].sub(to[i]));
    }
    return delta;
};
exports.getDeltaProportion = getDeltaProportion;
/**
 * Check that the sum of positions are equal to 10000
 * @param balance currentPositon
 * @returns an boolean indicating if the positions are well defined
 */
var checkPropotions = function (balance) {
    var sum = ethers_1.BigNumber.from('0');
    for (var i = 0; i < balance.length; i++) {
        sum = sum.add(balance[i]);
    }
    return sum.eq(ethers_1.BigNumber.from(10000)) ? true : false;
};
exports.checkPropotions = checkPropotions;
/**
 * Get the index of all debits
 * @param delta delta between the currentPositon and the desired Position
 * @returns an array of all debits index
 */
var findDebit = function (delta) {
    var debits = [];
    for (var i = 0; i < delta.length; i++) {
        if (delta[i].lt(0)) {
            debits.push(i);
        }
    }
    return debits;
};
/**
 * Get the index of all credits
 * @param delta delta between the currentPositon and the desired Position
 * @returns an array of all credits index
 */
var findCredit = function (delta) {
    var credits = [];
    for (var i = 0; i < delta.length; i++) {
        if (delta[i].gt(0)) {
            credits.push(i);
        }
    }
    return credits;
};
/**
 * Get the index of the minimal debit
 * @param delta delta between the currentPositon and the desired Position
 * @returns a number
 */
var minDebit = function (delta) {
    var debits = findDebit(delta);
    var min = ethers_1.BigNumber.from(100000);
    var index = 999; /// value if no debit found
    for (var i = 0; i < debits.length; i++) {
        if (delta[debits[i]].abs().lt(min)) {
            min = delta[debits[i]].abs();
            index = debits[i];
        }
    }
    return index;
};
exports.minDebit = minDebit;
/**
 * Get the index of the maximal credit
 * @param delta delta between the currentPositon and the desired Position
 * @returns a number
 */
var maxCredit = function (delta) {
    var credits = findCredit(delta);
    var max = ethers_1.BigNumber.from(0);
    var index = 999; /// value if no debit found
    for (var i = 0; i < credits.length; i++) {
        if (max.lte(delta[credits[i]])) {
            max = delta[credits[i]];
            index = credits[i];
        }
    }
    return index;
};
exports.maxCredit = maxCredit;
/**
 * Get the minimum between two BigNumber
 * @param x1 a BigNumber
 * @param x2 a BigNumber
 * @returns a BigNumber
 */
var min = function (x1, x2) {
    if (x1.gte(x2)) {
        return x2;
    }
    else {
        return x1;
    }
};
/**
 * Check that every array of a SwapRebalance object have the same length
 * @param swapData SwapRebalance
 */
var checkLength = function (swapData) {
    if (!(swapData.tokensAddresses.length == swapData.tokensBalances.length &&
        swapData.tokensBalances.length == swapData.positions.length &&
        swapData.positions.length == swapData.desiredPositions.length)) {
        throw enums_1.SDSWAP_ERRORS.DIFFERENT_LENGTHS;
    }
};
/**
 * Rebalance the proportion of results in the proportion of demand and the priority given to the small deficit
 * @param swapData SwapRebalance
 * @param networkID number TransactionsToParaswap[]
 * @returns an array of TransactionsToParaswap[]
 */
var performFillTheMinFirst = function (swapData, networkID) { return __awaiter(void 0, void 0, void 0, function () {
    var transactionsToParaswap, assetsAmountinToken, checkNewbalance, positions, tokensDecimals, i, delta, costmin, positive, positivesIndexList, negative, creditIndex, toRebalance_1, srcToken, destToken, srcAmount, cost, toRebalance, amount, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                transactionsToParaswap = [];
                assetsAmountinToken = swapData.tokensBalances;
                checkNewbalance = (0, exports.checkPropotions)(swapData.desiredPositions);
                positions = __spreadArray([], swapData.positions, true);
                tokensDecimals = [];
                for (i = 0; i < swapData.tokensAddresses.length; i++) {
                    tokensDecimals[i] = hp.getTokenPropertiesFromAddress(networkID, swapData.tokensAddresses[i]).decimals;
                }
                if (!checkNewbalance) {
                    throw enums_1.SDSWAP_ERRORS.WRONG_PROPORTION;
                }
                checkLength(swapData);
                delta = (0, exports.getDeltaProportion)(positions, swapData.desiredPositions);
                _a.label = 1;
            case 1:
                if (!((0, exports.minDebit)(delta) != 999 && positions[(0, exports.maxCredit)(delta)].gt(2))) return [3 /*break*/, 6];
                costmin = Infinity;
                positive = 99;
                positivesIndexList = findCredit(delta);
                negative = (0, exports.minDebit)(delta);
                creditIndex = 0;
                _a.label = 2;
            case 2:
                if (!(creditIndex < positivesIndexList.length)) return [3 /*break*/, 5];
                toRebalance_1 = Math.min(Math.abs(delta[negative].toNumber()), Math.abs(delta[positivesIndexList[creditIndex]].toNumber()));
                srcToken = (0, helper_1.getToken)(swapData.tokensAddresses[positivesIndexList[creditIndex]], tokensDecimals[positivesIndexList[creditIndex]]);
                destToken = (0, helper_1.getToken)(swapData.tokensAddresses[negative], tokensDecimals[negative]);
                srcAmount = assetsAmountinToken[positivesIndexList[creditIndex]]
                    .mul(toRebalance_1)
                    .div(100);
                return [4 /*yield*/, (0, helper_1.getSwapCost)(srcToken, destToken, srcAmount.toString(), networkID)];
            case 3:
                cost = _a.sent();
                // ToRebalance value must be superior of 0.1$
                if (toRebalance_1 > 0 &&
                    swapData.vaultValueUSD.mul(toRebalance_1).div(10000).gt(config_1.swapPackageConfig.minSwapVolumeUSD)) {
                    if (costmin > cost) {
                        costmin = cost;
                        positive = positivesIndexList[creditIndex];
                    }
                }
                else {
                    throw enums_1.SDSWAP_ERRORS.TO_REBALANCE_INSUFFICIENT;
                }
                _a.label = 4;
            case 4:
                creditIndex++;
                return [3 /*break*/, 2];
            case 5:
                toRebalance = min(delta[negative].abs(), delta[positive].abs());
                amount = assetsAmountinToken[positive].mul(toRebalance).div(positions[positive]);
                tx = {
                    srcToken: swapData.tokensAddresses[positive],
                    srcDecimal: tokensDecimals[positive],
                    destToken: swapData.tokensAddresses[negative],
                    destDecimal: tokensDecimals[negative],
                    amount: amount,
                };
                transactionsToParaswap.push(tx);
                positions[negative] = positions[negative].add(toRebalance);
                positions[positive] = positions[positive].sub(toRebalance);
                assetsAmountinToken[positive] = assetsAmountinToken[positive].sub(amount);
                delta = (0, exports.getDeltaProportion)(positions, swapData.desiredPositions);
                return [3 /*break*/, 1];
            case 6: return [2 /*return*/, transactionsToParaswap];
        }
    });
}); };
exports.performFillTheMinFirst = performFillTheMinFirst;
/**
 * Rebalance the proportion of results in the proportion of demand based on the priority of the assets
 * @param swapData SwapRebalance
 * @returns an array of TransactionsToParaswap[]
 */
var performNaiveRebalancing = function (swapData, networkID) { return __awaiter(void 0, void 0, void 0, function () {
    var transactionsToParaswap, assetsAmountinToken, checkNewbalance, positions, tokensDecimals, i, index, delta, negatives, debitIndex, toRebalance, amount, tx;
    return __generator(this, function (_a) {
        transactionsToParaswap = [];
        assetsAmountinToken = swapData.tokensBalances;
        checkNewbalance = (0, exports.checkPropotions)(swapData.desiredPositions);
        positions = __spreadArray([], swapData.positions, true);
        tokensDecimals = [];
        for (i = 0; i < swapData.tokensAddresses.length; i++) {
            tokensDecimals[i] = hp.getTokenPropertiesFromAddress(networkID, swapData.tokensAddresses[i]).decimals;
        }
        if (!checkNewbalance) {
            throw enums_1.SDSWAP_ERRORS.WRONG_DESIRED_POSITIONS;
        }
        checkLength(swapData);
        for (index = 0; index < positions.length; index++) {
            delta = (0, exports.getDeltaProportion)(positions, swapData.desiredPositions);
            if (delta[index].gt(2)) {
                negatives = findDebit(delta);
                for (debitIndex = 0; debitIndex < negatives.length; debitIndex++) {
                    delta = (0, exports.getDeltaProportion)(positions, swapData.desiredPositions);
                    toRebalance = min(delta[negatives[debitIndex]].abs(), delta[index].abs()).toNumber();
                    // console.log('hmm');
                    // console.log(toRebalance);
                    // console.log(positions);
                    if (!swapData.vaultValueUSD.isZero()) {
                        /// enables rebalancing on empty vaults)
                        if (toRebalance > 0) {
                            amount = assetsAmountinToken[index].mul(toRebalance).div(positions[index]);
                            if (swapData.vaultValueUSD
                                .mul(toRebalance)
                                .div(10000)
                                .gt(config_1.swapPackageConfig.minSwapVolumeUSD)) {
                                tx = {
                                    srcToken: swapData.tokensAddresses[index],
                                    srcDecimal: tokensDecimals[index],
                                    destToken: swapData.tokensAddresses[negatives[debitIndex]],
                                    destDecimal: tokensDecimals[negatives[debitIndex]],
                                    amount: amount,
                                };
                                transactionsToParaswap.push(tx);
                                assetsAmountinToken[index] = assetsAmountinToken[index].sub(amount);
                                positions[negatives[debitIndex]] = positions[negatives[debitIndex]].add(toRebalance);
                                positions[index] = positions[index].sub(toRebalance);
                                delta = (0, exports.getDeltaProportion)(positions, swapData.desiredPositions);
                                if (delta[index].lte(0)) {
                                    break;
                                }
                            }
                            else {
                                assetsAmountinToken[index] = assetsAmountinToken[index].sub(amount);
                                positions[negatives[debitIndex]] = positions[negatives[debitIndex]].add(toRebalance);
                                positions[index] = positions[index].sub(toRebalance);
                                delta = (0, exports.getDeltaProportion)(positions, swapData.desiredPositions);
                            }
                        }
                    }
                    else {
                        /// here the vault is empty. Only the posisitons are rebalanced.
                        positions[negatives[debitIndex]] = positions[negatives[debitIndex]].add(toRebalance);
                        positions[index] = positions[index].sub(toRebalance);
                        delta = (0, exports.getDeltaProportion)(positions, swapData.desiredPositions);
                        if (delta[index].lte(0)) {
                            break;
                        }
                    }
                }
            }
        }
        //console.log(positions);
        return [2 /*return*/, transactionsToParaswap];
    });
}); };
exports.performNaiveRebalancing = performNaiveRebalancing;
/**
 * Getting paraswap transactions for Augustus contract
 * @param txs array of transactions to go given by performNaiveRebalancing or performFillTheMinFirst
 * @param networkID chainID
 * @param userAddress The address of the caller (usually the vault)
 * @param slippage slippage in BPS
 * @param maxImpact the maximal price imapct tolerated in BPS
 * @param receiver The address of the receiver of the swaps (usually the vault)
 * @returns an array containing the response of the API for each transactions
 */
var formatQueriesForParaswap = function (txs, networkID, userAddress, slippage, maxImpact, receiver) { return __awaiter(void 0, void 0, void 0, function () {
    var queries, i, tx, swapTx;
    return __generator(this, function (_a) {
        queries = [];
        //let swapTxs = Promise<paraHP.TransactionParams>;
        for (i = 0; i < txs.length; i++) {
            tx = txs[i];
            swapTx = hp.getSwapTransaction({
                srcAmount: tx.amount.toString(),
                srcToken: tx.srcToken,
                destToken: tx.destToken,
                srcDecimal: tx.srcDecimal,
                destDecimal: tx.destDecimal,
                networkID: networkID,
                userAddress: userAddress,
                slippage: slippage,
                maxImpact: maxImpact,
                receiver: receiver,
            });
            // console.log('reponse du POST');
            // console.log(swapTx);
            queries.push(swapTx);
        }
        return [2 /*return*/, Promise.all(queries).then(function (response) {
                // console.log('reponse du POST');
                // response.map((truc) => console.log(truc));
                return response;
            })];
    });
}); };
exports.formatQueriesForParaswap = formatQueriesForParaswap;
//# sourceMappingURL=swaper.js.map