import { BigNumber } from 'ethers';
export interface SwapConfig {
    networkID: number;
    signerAddress: string;
    recipientAddress: string;
}
export interface SwapDeposit {
    baseToken: string;
    amountIn: BigNumber;
    tokensAddresses: string[];
    optimisation: SwapOptimisation;
    positions: BigNumber[];
}
export interface SwapRedeem {
    shareAmount: BigNumber;
    shareSupply: BigNumber;
    baseToken: string;
    tokensAddresses: string[];
    tokensBalances: BigNumber[];
    optimisation: SwapOptimisation;
}
export interface SwapRebalance {
    tokensAddresses: string[];
    tokensBalances: BigNumber[];
    positions: BigNumber[];
    desiredPositions: BigNumber[];
    vaultValueUSD: BigNumber;
    optimisation: SwapOptimisation;
}
export interface SwapOptimisation {
    slippage: string;
    maxImpact: string;
}
